(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***             Copyright (c) 1995 - 2002 by -=Assarbad [GoP]=-            ***
 ***                                                                        ***
 ***      ____________                 ___________                          ***
 ***     /\   ________\               /\   _____  \     UIN: 281645         ***
 ***    /  \  \       /    __________/  \  \    \  \    AIM: nixlosheute    ***
 ***    \   \  \   __/___ /\   _____  \  \  \____\  \        nixahnungnicht ***
 ***     \   \  \ /\___  \  \  \    \  \  \   _______\                      ***
 ***      \   \  \ /   \  \  \  \    \  \  \  \      /  Assarbad@gmx.info   ***
 ***       \   \  \_____\  \  \  \____\  \  \  \____/                       ***
 ***        \   \___________\  \__________\  \__\                           ***
 ***         \  /           /  /          /  /  /                           ***
 ***          \/___________/ \/__________/ \/__/                            ***
 ***                                                                        ***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                       Privet iz Germanij                               ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ***               [for questions/proposals drop me a mail]                 ***
 *********************************************************** ASCII by Assa ****
 ******************************************************************************)

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2002, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

function GetClassNameFromWnd(hwnd: HWND): string;
(*
  Functionality:
    This function fills a string with the classname of the window given as the
    parameter.
    [GENERIC]
*)
var
  pc: pchar;
const
  maxbufsize = 32767;
  //Win9x does not like buffer size above 32k-1 - I also reported this to MS
  //after 8 month I got no feedback yet ... I guess this is MS's policy 2002-10-31
begin
// Default return value
  result := '';
// Allocate memory
  pc := GetMemory(maxbufsize);
// If successful ...
  if Assigned(pc) then
  try
// Fill with zeroes
    ZeroMemory(pc, maxbufsize);
// If Window still exists ...
    if IsWindow(hwnd) then
// Get its class name and write it into PC
      if GetClassname(hwnd, pc, maxbufsize) > 0 then
// Copy PC as return value
        SetString(result, pc, lstrlen(pc));
  finally
// Free allocated memory
    FreeMemory(pc);
  end;
end;

function GetTextFromWnd(hwnd: HWND): string;
(*
  Functionality:
    This function gets the text associated with the given window.
    [GENERIC]

There's another much faster version of GetWindowText on NT platforms, here's the
definition ... although I'll not use this proprietary code here.

function InternalGetWindowText(
  hWnd:HWND;
  lpString:PWideChar; //unicode!!
  nMaxCount:integer
  ):integer; stdcall; external 'user32.dll' name 'InternalGetWindowText';
*)
var
  l: integer;
  pc: pchar;
begin
  result := '';
// Get length of text ... could cause buffer overflow if not error checked!!!
  l := sendmessage(hwnd, WM_GETTEXTLENGTH, 0, 0) + 1;
  if l > 0 then
  begin
// Allocate memory
    pc := GetMemory(l);
    if Assigned(pc) then
    try
// Fill allocated memory with zeroes
      ZeroMemory(pc, l);
// Get text (max len = l)
      SendMessage(hwnd, WM_GETTEXT, l, Integer(pc));
// Set return value
      SetString(result, pc, l);
    finally
// Free allocated memory
      FreeMemory(pc);
    end;
  end;
end;

procedure Show32bitText(hwnd: HWND; ctrl: Word; card: Cardinal);
(*
  Functionality:
    This function shows a 32bit (or less) integer in unsigned form and
    hexadecimal notation, given the dialog and the control id.
    [SPECIFIC]
*)
begin
  case card of
    0: setdlgitemtext(hwnd, ctrl, @none_text[1]);
  else
    setdlgitemtext(hwnd, ctrl, @Format(hex_frmt, [card])[1]);
  end;
end;

procedure ShowIconText(hwnd: HWND; ctrl: Word; card: Cardinal);
(*
  Functionality:
    This function shows a 32bit (or less) integer in unsigned form and
    hexadecimal notation, given the dialog and the control id.
    In case the icon is system-wide, it's name is provided.
    [SPECIFIC]
*)
const
  _IDI_APPLICATION = 32512;
  _IDI_HAND = 32513;
  _IDI_QUESTION = 32514;
  _IDI_EXCLAMATION = 32515;
  _IDI_ASTERISK = 32516;
  _IDI_WINLOGO = 32517;
var
  s: string;
begin
  case HiWord(Card) <> 0 of
    true:
      Show32bitText(hwnd, ctrl, card);
  else
    if MAKEINTRESOURCE(Card) <> '' then
    begin
// Set the different known names for system supplied icons (there are probably more)
      case card of
        _IDI_APPLICATION: s := 'IDI_APPLICATION';
        _IDI_HAND: s := 'IDI_HAND';
        _IDI_QUESTION: s := 'IDI_QUESTION';
        _IDI_EXCLAMATION: s := 'IDI_EXCLAMATION';
        _IDI_ASTERISK: s := 'IDI_ASTERISK';
        _IDI_WINLOGO: s := 'IDI_WINLOGO';
      else
// Format into hexadecimal number
        s := Format(hex_frmt, [card]);
      end;
// Show it in the respective static control
      SetDlgItemText(hwnd, ctrl, @s[1])
    end
    else
// Probably some "real" handle, show it as hex number
      Show32bitText(hwnd, ctrl, card);
  end;
end;

function RectCoord2String(rect: TRect): string;
(*
  Functionality:
    This function returns a string that represents the coordinates given by the
    rect-parameter.
    [SPECIFIC]
*)
begin
  result := Format('(%d,%d):(%d,%d)', [rect.Left, rect.Top, rect.Right, rect.Bottom]);
end;

function runonNT: boolean;
(*
  Functionality:
    This function returns true if it executes on the NT platform and false
    elsewise.
    [GENERIC]
*)
begin
  result := (GetVersion and $80000000) = 0;
end;

function MyIsWindowVisible(hWnd: HWND): boolean;
(*
  Functionality:
    This function returns true the given window is visible.
    [GENERIC]
*)
begin
  result := BOOL(GetWindowLong(hWnd, GWL_STYLE) and WS_VISIBLE);
end;

function ResToString(Instance: hInst; ResName, ResType: string): string;
(*
  Functionality:
    This function returns a string from a text file contained as a resource.
    See binres on my webpage, too.
    [GENERIC]
*)
var
  ResSize,
    HG,
    HI: Cardinal;
  pc: PChar;
begin
  result := '';
// Get reference to resource.
  HI := FindResource(Instance, @resname[1], @ResType[1]);
  if HI <> 0 then
  begin
// Load it
    HG := LoadResource(Instance, HI);
    if HG <> 0 then
    try
      ResSize := SizeOfResource(Instance, HI);
// Get a pointer to the resource.
      pc := LockResource(HG);
// Set the return value.
      SetString(result, pc, ResSize);
    except;
    end;
  end;
end;

function InitMiscData: Boolean;
(*
  Functionality:
    Initialises the global memory that holds the target's parameters.
    [SPECIFIC]
*)
var
  pMem: Pointer;
begin
// Allocate memory for the MiscData structure.
  pMem := GetMemory(sizeof(TMiscData));
// If successful ...
  Result := Assigned(pMem);
  if Result then
  begin
// Set a global variable (could be a window property or something else, too).
    Globrefpointer := pMem;
// Initialise the allocated memory with zeroes
    ZeroMemory(pMem, sizeof(TMiscData));
  end;
end;

function DeInitMiscData: Boolean;
(*
  Functionality:
    This frees the memory occupied by the data that holds the target's params.
    [SPECIFIC]
*)
var
  pMem: PMiscData;
begin
// Get the pointer
  pMem := Globrefpointer;
// If not equal to zero/NIL
  Result := Assigned(pMem);
  if Result then
  begin
// Free it (No error checking, since the mem is freed at the end of execution).
    FreeMemory(pMem^.target_classname);
    FreeMemory(pMem^.target_assoctext);
    FreeMemory(pMem);
  end;
end;

procedure RemovePropertyList;
(*
  Functionality:
    Completely frees the occupied memory from reading out a windows properties.
    [SPECIFIC]
*)
var
  lastent,
    newent: Pointer;
begin
  if Assigned(listentry) then
  try
    lastent := listentry;
// Iterate through the list and free all allocated memory
    repeat
      newent := PPropertyList(lastent)^.nextentry;
// Free related name of property
      FreeMemory(PPropertyList(lastent)^.name_of_prop);
// Set NIL
      PPropertyList(lastent)^.name_of_prop := nil;
// Free related string value
      FreeMemory(PPropertyList(lastent)^.val_if_sz);
// Set NIL
      PPropertyList(lastent)^.val_if_sz := nil;
// Free the list entry itself
      FreeMemory(lastent);
// Go to the next entry
      lastent := newent;
    until lastent = nil;
  finally
// Finally set the listentry to NIL, so we know the list is empty.
    listentry := nil;
  end;
end;

function ReadProcessMemAsString(proc: THandle; Address: Pointer): string;
(*
  Functionality:
    Reads out a string (ANSI) from the specified address in the specified
    process. Breaks on any occuring #0 or in case reading fails.
    [SPECIFIC]
*)
var
  pc: pchar;
  i: integer;
  x: char;
const
  maxbufsize = $FFFF;
begin
// Default return value
  result := '';
// Temporary storage for pointer arithmetics
  pc := Address;
// Try reading each end every byte up to maxbufsize
  for i := 1 to maxbufsize do
  begin
    if ReadProcessMemory(proc, pc, @x, 1, PDWORD(nil)^) then
// On failure break, else increase our temporary pointer
      if x <> #0 then inc(pc) else break
    else break;
  end;
// Allocate memory
  pc := GetMemory(i);
// If successful
  if Assigned(pc) then
  try
// Fill the memory with zeroes
    ZeroMemory(pc, i);
// Read the process' memory (number of bytes to read = i)
    if ReadProcessMemory(proc, Address, pc, i, PDWORD(nil)^) then
// Set return value
      SetString(result, pc, lstrlen(pc))
  finally
// Finally free allocated memory
    FreeMemory(pc);
  end;
end;

function PropEnumProcEx(hwnd: HWND; lpszString: Pchar; hData: THandle; dwData: DWORD): BOOL; stdcall;
(*
  Functionality:
    This function enumerates the properties of a given window. It is a callback
    function. It fills specific structures with values that are lateron promoted
    to the user thru the properties-window.
    [SPECIFIC]

  Note, the lpszString parameter resides in _our_ own memory space, we can
  therefore directly access it without need for ReadProcessMemory()
*)
var
  news: string;
  sett: boolean;
  i: integer;
  temps: string;
  proc: THandle;
  valu, procid, readbytes: DWORD;
begin
// Get the process ID
  GetWindowThreadProcessId(hwnd, @procid);
// Open the resp. process
  proc := OpenProcess(PROCESS_VM_READ, false, procid);
// If siccessful ...
  if proc <> 0 then
  try
// Try ...
    try
// Reading the value as a string (hData as a pointer to a string)
      news := ReadProcessMemAsString(proc, Pointer(hData));
    except
// Else show failure
      news := badreadptr;
    end;
// Try ...
    try
// Reading a DWORD at the position hData points to if casted into a Pointer type
      ReadProcessMemory(proc, PDWORD(hData), @valu, sizeof(DWORD), readbytes);
    finally
// If successful, set flag else flag becomes false (this will report Invalid Pointer)
      sett := readbytes = sizeof(DWORD);
    end;
// Handle dependent on wether the list is empty or not.
    case Assigned(listentry) of
      FALSE:
        begin
// Allocate memory
          listentry := GetMemory(sizeof(TPropertyList));
// If successful ...
          if Assigned(listentry) then
          try
// Fill with zeroes
            ZeroMemory(listentry, sizeof(TPropertyList));
// No last entry ...
            PPropertyList(listentry)^.lastentry := nil;
// No next entry ...
            PPropertyList(listentry)^.nextentry := nil;
          except
// If something goes wrong, free all stuff ...
            FreeMemory(listentry);
// And set listentry to NIL to show it's still empty
            listentry := nil;
          end;
// Set the variable lastentry for later use outside this case statement
          lastentry := listentry;
        end
    else
      begin
// Allocate memory
        PPropertyList(lastentry)^.nextentry := GetMemory(sizeof(TPropertyList));
// If successful ...
        if assigned(PPropertyList(lastentry)^.nextentry) then
        try
// Fill with zeroes
          ZeroMemory(PPropertyList(lastentry)^.nextentry, sizeof(TPropertyList));
// We are last entry, so set nextentry to NIL
          PPropertyList(PPropertyList(lastentry)^.nextentry)^.nextentry := nil; // now we're last
// Set the predecessor
          PPropertyList(PPropertyList(lastentry)^.nextentry)^.lastentry := PPropertyList(lastentry)^.nextentry;
        except
// If something goes wrong, free memory
          FreeMemory(PPropertyList(lastentry)^.nextentry);
// Set pointer to NIL
          PPropertyList(lastentry)^.nextentry := nil;
        end;
// Use lastentry outside the case statement
        lastentry := PPropertyList(lastentry)^.nextentry;
      end;
    end;
// If lastentry <> NIL ...
    if Assigned(lastentry) then
    begin
// Check wether the high word of the name is zero, if so it is perhaps an atom
      case hiword(DWORD(lpszString)) = 0 of
// Read as binary value of 4 hexadecimal digits
        true:
          temps := Format('%4.4X', [lpszString]);
      else
// Else read as string
        try
// Read the string's value and copy it into our memory space
          ReadProcessMemory(proc, Pointer(lpszString^), @procid, sizeof(DWORD), readbytes);
// Set a string variable
          temps := Format('"%s" -> ^%8.8X', [lpszString, procid]);
        except
// If this fails, read out the pointer and set the string variable
          temps := Format('@%8.8X -> ' + badreadptr, [lpszString]);
        end;
      end;
// We need to copy all stuff into out list - check string length
      i := Length(temps) + 1;
// Allocate the according amount of memory
      PPropertyList(lastentry)^.name_of_prop := GetMemory(i);
// If successful ...
      if Assigned(PPropertyList(lastentry)^.name_of_prop) then
      try
// Fill with zeroes
        ZeroMemory(PPropertyList(lastentry)^.name_of_prop, i);
// And copy it
        lstrcpyn(PPropertyList(lastentry)^.name_of_prop, @temps[1], i);
      except
// Else fill with zeroes and set to NIL (= empty string)
        FreeMemory(PPropertyList(lastentry)^.name_of_prop);
        PPropertyList(lastentry)^.name_of_prop := nil;
      end;
// Same as above, but with the string value instead of the name ^^
      i := Length(news) + 1;
      PPropertyList(lastentry)^.val_if_sz := GetMemory(i);
      if Assigned(PPropertyList(lastentry)^.val_if_sz) then
      try
        ZeroMemory(PPropertyList(lastentry)^.val_if_sz, i);
        lstrcpyn(PPropertyList(lastentry)^.val_if_sz, @news[1], i);
      except
        FreeMemory(PPropertyList(lastentry)^.val_if_sz);
        PPropertyList(lastentry)^.val_if_sz := nil;
      end;
// Set the rest of the members
      PPropertyList(lastentry)^.value := hData;
      PPropertyList(lastentry)^.pointsto := valu;
      PPropertyList(lastentry)^.assigned_ref := sett;
    end;
// Go on with enumeration
    result := TRUE;
  finally
// Close our reference to the remote process
    CloseHandle(proc);
  end
// Problems ... so quit
  else
    result := FALSE;
end;

(*
Although this one is from Eugen, too - I also wrote such a function ... it is
very simple ;) ... MS gives the path to it ... see the PSDK

However, that time I wrote it myself I could not find Eugen's and now I can't
find mine ;)

[GENERIC]

function time_tToSystemTime(t : Integer): SYSTEMTIME;
const
 SecsTo1970: int64 = 116444736000000000;
var
  ft: Int64;
  st: SYSTEMTIME;
begin
  ft:= SecsTo1970 + Int64(t) * 10000000;

  FileTimeToSystemTime(FILETIME(ft), Result);
//  SystemTimeToTzSpecificLocalTime(nil, Result, Result);
end;
*)

procedure Setcheckbox(hwnd: HWND; ID: integer; value: boolean);
(*
  Functionality:
    Sets a checkbox given the dialog handle and the control ID
    [GENERIC]
*)
begin
  case value of
    TRUE: checkdlgbutton(hwnd, ID, BST_CHECKED);
    FALSE: checkdlgbutton(hwnd, ID, BST_UNCHECKED);
  end;
end;

function Getcheckbox(hwnd: HWND; ID: integer): boolean;
(*
  Functionality:
    Gets a checkbox's state given the dialog handle and the control ID
    [GENERIC]
*)
var x: WORD;
begin
  result := false;
  x := IsDlgButtonChecked(hWnd, ID);
  if x = BST_CHECKED then result := true;
end;

function RestrictModify(hwnd, trgt: Windows.HWND): boolean;
(*
  Functionality:
    Checks wether the target window belongs to our process. If so disallow
    modifications ;)
    [SPECIFIC]
*)
var
  enable: boolean;
begin
  enable := not (GetWindowThreadProcessId(trgt, nil) = GetCurrentThreadID);
  EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_MINIMIZE_RESTORE), enable);
  EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_CLOSETARGETWINDOW), enable);
  EnableWindow(GetDlgItem(hwnd, IDC_CHECK_ISENABLED), enable);
  EnableWindow(GetDlgItem(hwnd, IDC_CHECK_ISVISIBLE), enable);
  result := not enable;
end;

function CopyText2ClipBoard(hwnd: HWND; sztext: PChar): Boolean;
var
  hGlob: THandle;
  szCopy: PChar;
begin
  if OpenClipBoard(hwnd) then
  try
    hGlob := GlobalAlloc(GMEM_MOVEABLE, lstrlen(sztext) + 1);
    if hGlob <> 0 then
    begin
      szCopy := GlobalLock(hGlob);
      CopyMemory(szCopy, sztext, lstrlen(sztext));
      SetClipboardData(CF_TEXT, hGlob);
      GlobalUnlock(hGlob);
    end;
  finally
    CloseClipBoard;
  end;
end;

